import { ChangeDetectorRef, DoCheck, OnDestroy } from '@angular/core';
import { AbstractControl, ControlValueAccessor, FormGroupDirective, NgControl, NgForm, ValidationErrors, Validator } from '@angular/forms';
import { CanDisable, CanDisableCtor, CanUpdateErrorState, CanUpdateErrorStateCtor, DateAdapter, ErrorStateMatcher } from '@angular/material/core';
import { Months } from '../../models/months.model';
declare class SimpleDatepickerBase {
    _defaultErrorStateMatcher: ErrorStateMatcher;
    _parentForm: NgForm;
    _parentFormGroup: FormGroupDirective;
    ngControl: NgControl;
    constructor(_defaultErrorStateMatcher: ErrorStateMatcher, _parentForm: NgForm, _parentFormGroup: FormGroupDirective, ngControl: NgControl);
}
declare const _SimpleDatepickerMixinBase: CanDisableCtor & CanUpdateErrorStateCtor & typeof SimpleDatepickerBase;
export declare class DatepickerComponent extends _SimpleDatepickerMixinBase implements CanDisable, ControlValueAccessor, CanUpdateErrorState, DoCheck, Validator, OnDestroy {
    private cdRef;
    _defaultErrorStateMatcher: ErrorStateMatcher;
    ngControl: NgControl;
    dateAdapter: DateAdapter<Date>;
    dayPlaceholder: string;
    monthPlaceholder: string;
    yearPlaceholder: string;
    months: Months;
    get id(): string;
    set id(id: string);
    get value(): Date;
    set value(value: Date);
    get required(): boolean;
    set required(required: boolean);
    get min(): Date;
    set min(min: Date);
    get max(): Date;
    set max(max: Date);
    get errorState(): boolean;
    set errorState(errorState: boolean);
    get selectedDay(): number;
    set selectedDay(selectedDay: number);
    get startingYear(): number;
    get endingYear(): number;
    numberOfDays: number;
    selectedYear: number;
    selectedMonth: number;
    validationError: boolean;
    private _id;
    private _value;
    private _required;
    private _errorState;
    private _min;
    private _max;
    private _selectedDay;
    private previousDay;
    private localeSubscription;
    private uid;
    private validators;
    constructor(cdRef: ChangeDetectorRef, _defaultErrorStateMatcher: ErrorStateMatcher, _parentForm: NgForm, _parentFormGroup: FormGroupDirective, ngControl: NgControl, dateAdapter: DateAdapter<Date>);
    propagateChange: (_: any) => void;
    propagateTouched: () => void;
    private validatorOnChange;
    /** The form control validator for the min date. */
    private minValidator;
    /** The form control validator for the max date. */
    private maxValidator;
    private validator;
    private coerceDateProperty;
    daysInMonth(month: number, year?: number): number;
    updateDay(day: number): void;
    update(): void;
    emit(): void;
    validate(c: AbstractControl): ValidationErrors;
    registerOnValidatorChange(fn: () => void): void;
    ngDoCheck(): void;
    writeValue(value: Date): void;
    registerOnChange(fn: () => void): void;
    registerOnTouched(fn: () => void): void;
    setDisabledState?(isDisabled: boolean): void;
    ngOnDestroy(): void;
}
export {};
